searchData={"items":[{"type":"module","title":"JsonComparator","doc":"Provides functionality for comparing JSON structures with configurable comparison options.","ref":"JsonComparator.html"},{"type":"function","title":"JsonComparator.compare/3","doc":"Compares two JSON structures for equality with configurable options.\n\nThis function performs a deep comparison of two JSON structures, supporting various data types\nincluding maps, lists, DateTime objects, and structs. It provides configurable behavior for\nlist comparison and DateTime precision.\n\nBy default, this function stops and returns on the first difference found.\nUse the `deep_compare: true` option to collect all differences.","ref":"JsonComparator.html#compare/3"},{"type":"function","title":"Parameters - JsonComparator.compare/3","doc":"* `json1` - First JSON structure to compare\n  * `json2` - Second JSON structure to compare\n  * `opts` - Optional keyword list of comparison options:\n    * `:strict_list_order` - When `true`, lists must have identical order to be considered equal.\n      Defaults to `false`\n    * `:truncate_datetime_microseconds` - When `true`, DateTime comparisons ignore microseconds.\n      Defaults to `true`\n    * `:error_message` - Custom error message template to use when differences are found.\n      The string `%{path}` will be replaced with the path where the difference was found.\n      Defaults to \"Submitted JSONs do not match: %{path}\"\n    * `:deep_compare` - When `true`, collects all differences instead of stopping at the first one.\n      Defaults to `false`. When `true`, returns `{:error, differences}` where `differences` is a list\n      of `{path, details}` tuples.","ref":"JsonComparator.html#compare/3-parameters"},{"type":"function","title":"Returns - JsonComparator.compare/3","doc":"* `:ok` - When the structures are equal according to the comparison rules\n  * `{:error, message}` - When differences are found and `deep_compare: false`, where message is a\n     string indicating the path where the first difference was encountered\n  * `{:error, differences}` - When differences are found and `deep_compare: true`, where differences\n     is a list of tuples containing path and details about each difference","ref":"JsonComparator.html#compare/3-returns"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}